function sprint_racer:give_ids
scoreboard objectives setdisplay sidebar

scoreboard players set @a subtitleDelay 20

tag @e[name=w] remove needAnnounce

setblock 1507 116 417 light_blue_stained_glass
setblock 1507 116 403 red_stained_glass

#make sure displays are refreshed
team empty player
team empty spectator
team empty playerFinished
execute as @a[scores={points=..999}] run scoreboard players operation @s dummyPoints = @s points
scoreboard players reset * points
scoreboard players reset * KOs

time set 6000
gamerule doDaylightCycle false
weather clear

#removing "nodeState" so ALL activated nodes are forgotten between games, even ones in unloaded chunks
scoreboard objectives remove nodeState
scoreboard objectives add nodeState dummy

#removing "validEntity" so invalid entities lingering in the world will lost their score and get killed when their chunks are reloaded
scoreboard objectives remove validEntity
scoreboard objectives add validEntity dummy

#prevent invalid roundNumber stuff
execute if entity @e[name=w,tag=!optBattle,scores={roundNumber=6..}] run scoreboard players set @e[name=w] roundNumber 1
execute if entity @e[name=w,tag=optBattle] run scoreboard players set @e[name=w] roundNumber 5
execute if entity @e[name=w,tag=optRace,scores={roundNumber=5..}] run scoreboard players set @e[name=w] roundNumber 1
execute if entity @e[name=w,tag=optRace,scores={roundNumber2=4..}] run scoreboard players set @e[name=w] roundNumber2 1

#sidebar display for next round
function sprint_racer:game_logic/0/sidebar/__index_main

clear @a
gamemode adventure @a
function sprint_racer:reset_speeds
title @a actionbar [""]

tag @e[name=w] remove choosingTrack
#execute if entity @e[name=w,tag=choosingTrack,tag=!optChoose] run function sprint_racer_language:lobby/options/defaults
tag @e[tag=chosenTrack] remove chosenTrack
tag @e[name=w] remove clearImpulse
tag @e[name=w] remove allowPVP
tag @e[name=w] remove raining
tag @a remove playerVote1
tag @a remove playerVote2
tag @a remove playerVote3
tag @a remove noInventory
scoreboard players set @e[name=w] scriptMove 1

#optVote
#optChoose
#optRandom

scoreboard players reset @e[name=w] storm

scoreboard players set @e[name=w] gameTime 800
scoreboard players set @e[name=w] voteTime 600
scoreboard players operation @e[name=w,limit=1] gameTime = @e[name=w,limit=1] defLobbyTime
scoreboard players operation @e[name=w,limit=1] voteTime = @e[name=w,limit=1] defVoteTime
#go right to track selection if w has "choosingTrack" tag (cuts out extra wait time)
scoreboard players set @e[name=w,tag=choosingTrack] gameTime 0
scoreboard players set @e[name=w,tag=choosingTrack] voteTime 0

scoreboard players set @e[name=w,scores={defLobbyTime=15..19}] voteTime 10
scoreboard players set @e[name=w,scores={defLobbyTime=20..24}] voteTime 15
scoreboard players set @e[name=w,scores={defLobbyTime=25..29}] voteTime 20
scoreboard players set @e[name=w,scores={defLobbyTime=30..39}] voteTime 25
scoreboard players set @e[name=w,scores={defLobbyTime=40..44}] voteTime 30
scoreboard players set @e[name=w,scores={defLobbyTime=45..49}] voteTime 35
scoreboard players set @e[name=w,scores={defLobbyTime=50..59}] voteTime 40
scoreboard players set @e[name=w,scores={defLobbyTime=60..79}] voteTime 50
scoreboard players set @e[name=w,scores={defLobbyTime=80..99}] voteTime 60
scoreboard players set @e[name=w,scores={defLobbyTime=100..119}] voteTime 80
scoreboard players set @e[name=w,scores={defLobbyTime=120..}] voteTime 100

bossbar set minecraft:menutimer style notched_10
execute if entity @e[name=w,tag=optVote] store result bossbar minecraft:menutimer max run scoreboard players get @e[name=w,limit=1] voteTime
execute if entity @e[name=w,tag=optVote,scores={roundNumber=..4}] run function sprint_racer_language:lobby/bossbar_voting_race
execute if entity @e[name=w,tag=optVote,scores={roundNumber=..4}] run function sprint_racer:random/vote_options_race
execute if entity @e[name=w,tag=optVote,scores={roundNumber=5}] run function sprint_racer_language:lobby/bossbar_voting_battle
execute if entity @e[name=w,tag=optVote,scores={roundNumber=5}] run function sprint_racer:random/vote_options_battle

execute if entity @e[name=w,tag=!optChoose,scores={roundNumber=..4}] run team modify player color aqua
execute if entity @e[name=w,tag=!optChoose,scores={roundNumber=5}] run team modify player color red

execute if entity @e[name=w,tag=!optVote] store result bossbar minecraft:menutimer max run scoreboard players get @e[name=w,limit=1] defLobbyTime

bossbar set minecraft:speedo players

#summon entities and important stuff found in the hub
execute if entity @e[name=w,tag=summonProps] run function sprint_racer:game_logic/0/props/summon_props
tag @e[name=w,tag=summonProps] remove summonProps
execute unless entity @e[name=w,scores={gameState=0}] run function sprint_racer:game_logic/0/props/summon_props

#round number display
function sprint_racer:game_logic/0/update_round_display

scoreboard players set @e[name=w] gameState 0