function sprint_racer:give_ids

function sprint_racer:ai/general/ai_stop_all
kill @e[tag=lobbyprop]
kill @e[type=ender_pearl]

#halftick mode in realms when we have 6 or more players
scoreboard players set @e[name=w] playerCount 0
execute as @a[tag=playing] run scoreboard players add @e[name=w] playerCount 1
tag @e[name=w,tag=autotick,scores={playerCount=6..}] add halftick

scoreboard players reset @e[name=w] storm
weather clear

execute if entity @e[name=w,tag=needAnnounce] as @e[tag=chosenTrack] run function sprint_racer:game_logic/0/vote_preview/race/v_b_index_announce
execute if entity @e[name=w,tag=needAnnounce] as @a[tag=playing] at @s run playsound minecraft:block.note_block.bell master @s ~ 100000 ~ 100000 2
tag @e[name=w,tag=needAnnounce] remove needAnnounce

scoreboard objectives remove nodeState
scoreboard objectives add nodeState dummy

function sprint_racer:items/item_presets/_index_battle

#boiler-plate stuff for starting a battle
scoreboard players set @e[name=w] gameState 3
scoreboard players set @e[name=w] gameTime -50
scoreboard players set @e[name=w] currentTimeMin 0
scoreboard players set @e[name=w] currentTimeSec 0
scoreboard players set @e[name=w] currentTime 0
scoreboard players set @e[name=w] currentTimeMsec 0
scoreboard players set @e[name=w] currentTime 0
scoreboard players set @e[name=w] oTimer 0

scoreboard players reset @a enderman
scoreboard players reset @a anvil
scoreboard players reset @a burn
scoreboard players reset @a blindtime

tag @e[name=w] add allowPVP

team modify player seeFriendlyInvisibles false
team modify player color red

scoreboard players set @a actionbarState 1
scoreboard players set @a actionbarState2 0
scoreboard players set @a KOs 0
scoreboard players set @a subtitleDelay 0
scoreboard players set @a itemCooldown 0
scoreboard players set @a itemBlockState 0
scoreboard players reset @a death
scoreboard players reset @a death2
scoreboard players set @a scriptMove 0
scoreboard players set @a boundaryTimer 10

execute as @a run function parkour_grand_prix:game_logic/3/self_scoreboard_setup

bossbar set minecraft:lap1 players
bossbar set minecraft:lap2 players
bossbar set minecraft:lap3 players
bossbar set minecraft:lap4 players
bossbar set minecraft:lap5 players
bossbar set minecraft:lap6 players
bossbar set minecraft:lap7 players
bossbar set minecraft:lap8 players
bossbar set minecraft:lap9 players
bossbar set minecraft:lap10 players
bossbar set timeremaining players
bossbar set minecraft:unreadyprogress players

tag @e[name=w] remove ignoreCalc
tag @e[name=w] remove calcStart
tag @e[name=w] remove calcRunning
tag @e[name=w] remove calcEnd
tag @e[tag=finallap] remove finallap
tag @e[tag=finished] remove finished
scoreboard players set @e[name=w] timeOut 0
tag @a add noInventory
tag @e[tag=noInventory2] remove noInventory2

#players get points depending on how many other players they beat out
scoreboard players operation @e[name=w] addPoints = @e[name=w,limit=1] playerCountB
scoreboard players set @a givePoints 0

scoreboard players reset * KOs2
scoreboard objectives remove itemBlockState
scoreboard objectives add itemBlockState dummy

tag @a add firstplace
tag @a add firstplace2
scoreboard players set @s battPosDisplay 1

tag @e[name=w] remove initFailed
bossbar set minecraft:menutimer players
title @a times 0 45 5
title @a subtitle [""]
title @a title [""]
title @a actionbar [""]
clear @a
function sprint_racer:reset_speeds
scoreboard objectives setdisplay sidebar

#DEFAULTS, these can be overwritten by a specific track's initialization function
tag @e[name=w] remove noAItrack
scoreboard players set @e[name=w,tag=BAIautocount] optBAIcount 3
scoreboard players set @e[name=w] startType 0
scoreboard players set @e[name=w] timeRemaining 6208
gamerule doDaylightCycle false
tag @a remove darkHUD
tag @e[name=w] remove hideLaps
tag @e[name=w] remove noCharity

#the chosen track will run its special initialization function
execute as @e[limit=1,tag=chosenTrack,type=armor_stand] at @s run function sprint_racer:game_logic/3/_initialize_index


#if no chosen track exists, this function failed and we'll go back to the lobby (game logic 0)
execute unless entity @e[tag=chosenTrack,type=armor_stand,scores={rNumber=1..48}] run tag @e[name=w] add initFailed

execute unless entity @e[name=w,tag=initFailed] run effect give @a blindness 30 1 true
execute unless entity @e[name=w,tag=initFailed] run effect give @a invisibility 30 1 true
execute unless entity @e[name=w,tag=initFailed] run effect give @a resistance 30 255 true
execute unless entity @e[name=w,tag=initFailed] run effect give @a weakness 30 20 true
execute unless entity @e[name=w,tag=initFailed] run gamemode spectator @a