#note: playerCountC counts the number of unique scores that exist, NOT the player count
#unlike race mode, two or more players can share the same rank here (ex: "1st", "2nd")

#we have to worry about AI entities and also dead players here... woo

execute as @a[tag=playing] run scoreboard players operation @s dummyKOs = @s KOs
execute as @e[tag=AImaster] run scoreboard players operation @s dummyKOs = @s KOs
scoreboard players operation @a[tag=playing] dummyKOs -= @e[name=w,limit=1] dummyKOs
scoreboard players operation @e[tag=AImaster] dummyKOs -= @e[name=w,limit=1] dummyKOs
tag @a[tag=playing,scores={dummyKOs=0}] add thatsme
tag @e[tag=AImaster,scores={dummyKOs=0}] add thatsme

scoreboard players operation @a[tag=thatsme] battlePos = @e[name=w,limit=1] battlePos
scoreboard players operation @e[tag=thatsme] battlePos = @e[name=w,limit=1] battlePos
execute if entity @e[tag=thatsme] run tag @s add foundEm
execute if entity @e[tag=thatsme] run tag @s add foundEm
execute if entity @s[tag=foundEm] run scoreboard players add @e[name=w] battlePos 1
execute if entity @s[tag=foundEm] run scoreboard players add @e[name=w] playerCountC 1
tag @a[tag=thatsme] add ranked
tag @e[tag=thatsme] add ranked
tag @s remove foundEm

tag @e[tag=thatsme] remove thatsme
tag @a[tag=thatsme] remove thatsme

execute unless entity @a[tag=playing,scores={dummyKOs=-1}] unless entity @e[tag=AImaster,scores={dummyKOs=-1}] run scoreboard players remove @e[name=w] dummyKOs 1
scoreboard players remove @e[name=w] dummyKOs 1

#using the magic of recursion, keep calculating until every player is accounted for...
execute if entity @e[name=w,scores={dummyKOs=0..}] if entity @a[tag=playing,tag=!ranked,scores={KOs=0..100}] run tag @s add loopThisPlease
execute if entity @e[name=w,scores={dummyKOs=0..}] if entity @e[tag=AImaster,tag=!ranked,scores={KOs=0..100}] run tag @s add loopThisPlease
execute if entity @s[tag=loopThisPlease] run function sprint_racer:game_logic/3/rank_calc_looper