execute if entity @s[scores={elytraTimer=1}] run function sprint_racer:ai/general/clear_old_ai_targets
execute if entity @s[scores={elytraTimer=1}] run summon armor_stand ~ ~ ~ {Invulnerable:1b,Invisible:1,Tags:["elytraGuide","gimmeTag","needsDirection"],ArmorItems:[{},{},{id:"minecraft:elytra",Count:1b,tag:{Unbreakable:1b,Enchantments:[{id:"minecraft:vanishing_curse",lvl:1s}]}},{}]}
execute if entity @s[scores={elytraTimer=1}] run function sprint_racer:ai/general/behaviors/elytra_flight/give_elytra_tag

scoreboard players set @s aiStuckTime 0

execute if entity @s[tag=ai1] run tag @e[tag=elytraG1] add myElytra
execute if entity @s[tag=ai2] run tag @e[tag=elytraG2] add myElytra
execute if entity @s[tag=ai3] run tag @e[tag=elytraG3] add myElytra
execute if entity @s[tag=ai4] run tag @e[tag=elytraG4] add myElytra
execute if entity @s[tag=ai5] run tag @e[tag=elytraG5] add myElytra
execute if entity @s[tag=ai6] run tag @e[tag=elytraG6] add myElytra
execute if entity @s[tag=ai7] run tag @e[tag=elytraG7] add myElytra
execute if entity @s[tag=ai8] run tag @e[tag=elytraG8] add myElytra
execute if entity @s[tag=ai9] run tag @e[tag=elytraG9] add myElytra
scoreboard players set @e[tag=myElytra] lifespan 7

scoreboard players add @s[scores={elytraTimer=..99}] elytraTimer 1
execute if entity @e[name=w,tag=halftick] run scoreboard players add @s[scores={elytraTimer=3..99}] elytraTimer 1

execute if entity @s[scores={elytraTimer=..30}] run particle minecraft:cloud ~ ~ ~ 0.2 0.2 0.2 0 2 force

#follow the elytra, pretend we're flying
execute if entity @s[scores={elytraTimer=3..}] run tp @s @e[limit=1,sort=nearest,tag=myElytra]

#slow falling in case flight fails
effect give @s slow_falling 5 0 false

#give elytra via data merge
execute if entity @s[scores={elytraTimer=30..31}] as @e[tag=myElytra] run data merge entity @s {FallFlying:1b}

#particles
execute as @e[tag=myElytra,nbt={FallFlying:1b}] at @s run particle minecraft:instant_effect ^.8 ^.2 ^-2 0.0 0.0 0.0 0 1 force
execute as @e[tag=myElytra,nbt={FallFlying:1b}] at @s run particle minecraft:instant_effect ^-.8 ^.2 ^-2 0.0 0.0 0.0 0 1 force

#remove elytra
execute if entity @s[scores={elytraTimer=10..},tag=inWater] run tag @s add removeElytra
execute if entity @s[scores={elytraTimer=10..}] if entity @e[tag=myElytra,nbt={OnGround:1b}] run tag @s add removeElytra
execute if entity @s[scores={elytraTimer=10..}] unless entity @e[tag=myElytra] run tag @s add removeElytra
execute if entity @s[tag=removeElytra] run scoreboard players set @s elytraTimer 0
execute if entity @s[tag=removeElytra] run scoreboard players set @s rateAccel 300
execute if entity @s[tag=removeElytra] run scoreboard players set @s rateDecel 0
execute if entity @s[tag=removeElytra,nbt={OnGround:1b}] run effect clear @s minecraft:slow_falling

#movement logic depends on gamemode
execute if entity @e[name=w,scores={gameState=1}] run function sprint_racer:ai/general/behaviors/elytra_flight/race_pick_target
execute if entity @e[name=w,scores={gameState=3}] run function sprint_racer:ai/general/behaviors/elytra_flight/battle_pick_target

execute if entity @s[tag=removeElytra] run scoreboard players set @s aiSubBehavior 0
execute if entity @s[tag=removeElytra] run scoreboard players set @s aiSubBTimer 0
execute if entity @s[tag=removeElytra] run scoreboard players set @s aiBehavior 1
execute if entity @s[tag=removeElytra] run kill @e[tag=myElytra]
tag @s[tag=removeElytra] remove removeElytra

tag @e[tag=myElytra] remove myElytra