#send players to spawn if they aren't at spawn
execute if entity @e[name=w,tag=!choosingTrack] as @a[x=1550,y=108,z=406,distance=150..] at @s run function sprint_racer:game_logic/0/goto_spawn

execute if entity @e[name=w,tag=choosingTrack] run effect give @a[x=2479,y=110,z=399,distance=200..] blindness 2 10 true
execute if entity @e[name=w,tag=choosingTrack] run tp @a[x=2479,y=110,z=399,distance=200..] ~ ~ ~ 180 30
execute if entity @e[name=w,tag=choosingTrack] run clear @a[x=2479,y=110,z=399,distance=200..]
execute if entity @e[name=w,tag=choosingTrack] run scoreboard players reset @a[x=2479,y=110,z=399,distance=200..] enderman
execute if entity @e[name=w,tag=choosingTrack] run spreadplayers 2479 399 50 75 false @a[x=2479,y=110,z=399,distance=200..]

#execute if entity @e[name=w,tag=choosingTrack] run tp @a[x=2479,y=110,z=399,distance=200..] 2476 112 378 180 30


#timer and lobby logic
scoreboard players set @e[name=w,scores={oTimer=21..}] oTimer 0
scoreboard players add @e[name=w] oTimer 1

scoreboard players remove @e[name=w,scores={oTimer=20,voteTime=1..}] voteTime 1
scoreboard players remove @e[name=w,scores={oTimer=20,gameTime=1..}] gameTime 1

tag @e[name=w,scores={oTimer=20,voteTime=1..},tag=!clearImpulse] add clearImpulse
execute if entity @e[name=w,tag=optVote] run function sprint_racer:game_logic/0/lobby_vote
execute if entity @e[name=w,tag=optRandom] run function sprint_racer:game_logic/0/lobby_random
execute if entity @e[name=w,tag=optChoose,tag=!choosingTrack] run function sprint_racer:game_logic/0/lobby_choose

bossbar set minecraft:menutimer players @a[tag=lobby]

#bossbar showing how many players are needed to pause the menu
bossbar set minecraft:readyprogress players
bossbar set minecraft:unreadyprogress players @a[tag=playing,tag=!readyup]
scoreboard players set @e[name=w] unReadyCount 0
execute as @a[tag=playing,tag=!readyup] run scoreboard players add @e[name=w] unReadyCount 1
execute store result bossbar minecraft:unreadyprogress value run scoreboard players get @e[name=w,limit=1] unReadyCount
execute store result bossbar minecraft:unreadyprogress max run scoreboard players get @e[name=w,limit=1] readyRequired
function sprint_racer_language:lobby/bossbar_unready_up


#repeat some stuff if half tick mode is enabled
execute if entity @e[name=w,tag=halftick] run function sprint_racer:game_logic/0/gl0_main_ready_echo


#time's up, start gameplay
execute if entity @e[name=w,tag=optRandom,scores={gameTime=0,roundNumber=..4}] run function sprint_racer:random/random_track_race
execute if entity @e[name=w,tag=optRandom,scores={gameTime=0,roundNumber=5..}] run function sprint_racer:random/random_track_battle
execute if entity @e[name=w,tag=!optChoose,scores={gameTime=0,roundNumber=..4}] run function sprint_racer:game_logic/1/_initialize
execute if entity @e[name=w,tag=!optChoose,scores={gameTime=0,roundNumber=5}] run function sprint_racer:game_logic/3/_initialize
execute if entity @e[name=w,tag=optChoose,scores={gameTime=0}] run function sprint_racer:game_logic/0/choose_track