kill @e[tag=lobbyprop]

execute as @e[type=item_frame,tag=fixframe] run data merge entity @s {ItemRotation:0b,Invulnerable:1b,Silent:1b}


#item chests
execute unless entity @e[name=w,tag=halftick] run scoreboard players set @e[tag=node,tag=itemchest,x=1610,y=87,z=406,distance=..125] itemBlockState 100
execute if entity @e[name=w,tag=halftick] run schedule function sprint_racer:game_logic/0/props/halftick_item_chest_spawn 60t
kill @e[tag=itemcontainer]


#floating texts
function sprint_racer_language:lobby/floating_texts


#place or remove options signs based on map mode
execute unless entity @e[name=w,tag=realms] run function sprint_racer_language:lobby/options/restore_options_signs
execute if entity @e[name=w,tag=realms] run function sprint_racer:game_logic/0/props/remove_options_signs


#flamingo
summon armor_stand 1637 89 403 {Tags:["lobbyprop","creditstand"],Invulnerable:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[94f],ArmorItems:[{id:"leather_boots",Count:1b,tag:{display:{color:6513507}}},{id:"leather_leggings",Count:1b,tag:{display:{color:2783345}}},{id:"leather_chestplate",Count:1b,tag:{display:{color:4045012}}},{id:"player_head",Count:1b,tag:{SkullOwner:"Flamingosaurus"}}],HandItems:[{id:"chain_command_block",Count:1b},{id:"iron_pickaxe",Count:1b}],CustomName:"{\"text\":\"Flamingosaurus\",\"color\":\"dark_aqua\"}",CustomNameVisible:1b,DisabledSlots:2039583,Pose:{Head:[13f,0f,344f],RightLeg:[339f,0f,13f],LeftArm:[0f,254f,212f],RightArm:[350f,199f,28f]}}

#vio
summon armor_stand 1637 89 409 {Tags:["lobbyprop","creditstand"],Invulnerable:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[94f],ArmorItems:[{id:"leather_boots",Count:1b,tag:{display:{color:13016304}}},{id:"iron_leggings",Count:1b},{id:"leather_chestplate",Count:1b,tag:{display:{color:14223833}}},{id:"player_head",Count:1b,tag:{SkullOwner:"VioletRosa"}}],HandItems:[{},{id:"poppy",Count:1b}],CustomName:"{\"text\":\"VioletRosa\",\"color\":\"light_purple\"}",CustomNameVisible:1b,DisabledSlots:2039583,Pose:{Head:[360f,0f,13f],LeftLeg:[0f,0f,341f],RightLeg:[0f,0f,4f],LeftArm:[0f,0f,267f],RightArm:[346f,0f,144f]}}

#jayjo
summon armor_stand 1637 89 398 {Tags:["lobbyprop","creditstand"],Invulnerable:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[94f],ArmorItems:[{id:"leather_boots",Count:1b,tag:{display:{color:16751918}}},{id:"leather_leggings",Count:1b,tag:{display:{color:10244864}}},{id:"leather_chestplate",Count:1b,tag:{display:{color:16746496}}},{id:"player_head",Count:1b,tag:{SkullOwner:"Jayjo_"}}],CustomName:"{\"text\":\"Jayjo_\",\"color\":\"gold\"}",CustomNameVisible:1b,DisabledSlots:2039583,Pose:{Head:[339f,15f,0f],LeftLeg:[282f,350f,0f],RightLeg:[64f,354f,0f],LeftArm:[181f,0f,23f],RightArm:[173f,0f,303f]}}

#mcfilms
summon armor_stand 1637 89 396 {Tags:["lobbyprop","creditstand"],Invulnerable:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[61f],ArmorItems:[{id:"leather_boots",Count:1b,tag:{display:{color:2555878}}},{id:"leather_leggings",Count:1b,tag:{display:{color:5332090}}},{id:"leather_chestplate",Count:1b,tag:{display:{color:1572836}}},{id:"player_head",Count:1b,tag:{SkullOwner:"MCFilms"}}],CustomName:"{\"text\":\"MCFilms\",\"color\":\"aqua\"}",CustomNameVisible:1b,DisabledSlots:2039583,Pose:{Head:[0f,32f,0f],LeftArm:[322f,0f,344f],RightArm:[2f,0f,356f]}}

#mantis
summon armor_stand 1637 89 414 {Tags:["lobbyprop","creditstand"],Invulnerable:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[94f],ArmorItems:[{id:"leather_boots",Count:1b,tag:{display:{color:1819709}}},{id:"leather_leggings",Count:1b,tag:{display:{color:8874304}}},{id:"leather_chestplate",Count:1b,tag:{display:{color:2800165}}},{id:"player_head",Count:1b,tag:{SkullOwner:"ReflectedMantis"}}],CustomName:"{\"text\":\"ReflectedMantis\",\"color\":\"green\"}",CustomNameVisible:1b,DisabledSlots:2039583,Pose:{Head:[0f,0f,352f],LeftLeg:[26f,0f,0f],RightLeg:[331f,0f,0f],LeftArm:[23f,0f,0f],RightArm:[320f,23f,0f]}}

#marioman
summon armor_stand 1637 89 416 {Tags:["lobbyprop","creditstand"],Invulnerable:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Rotation:[94f],ArmorItems:[{id:"leather_boots",Count:1b,tag:{display:{color:8738584}}},{id:"leather_leggings",Count:1b,tag:{display:{color:2177517}}},{id:"leather_chestplate",Count:1b,tag:{display:{color:16721446}}},{id:"player_head",Count:1b,tag:{SkullOwner:"Marioman237"}}],CustomName:"{\"text\":\"Marioman237\",\"color\":\"red\"}",CustomNameVisible:1b,DisabledSlots:2039583,Pose:{LeftLeg:[271f,0f,0f],RightLeg:[47f,0f,0f],LeftArm:[224f,0f,0f],RightArm:[49f,0f,0f]}}

#credits
function sprint_racer_language:lobby/credits

#paintings
summon painting 1591 95 378 {Facing:0b,Invulnerable:1b,Tags:["lobbyprop"],Motive:"minecraft:graham"}
summon painting 1595 95 378 {Facing:0b,Invulnerable:1b,Tags:["lobbyprop"],Motive:"minecraft:graham"}

#jailbirds
function sprint_racer:game_logic/0/props/update_jail_zombies

#preview items
summon item 1575 91 439 {Tags:["lobbyprop","itempreview","ip1"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:snowball",Count:3,tag:{Tags:["stay"]}}}
summon item 1577 91 439 {Tags:["lobbyprop","itempreview","ip2"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:dispenser",Count:3,tag:{Tags:["stay"]}}}
summon item 1579 91 439 {Tags:["lobbyprop","itempreview","ip3"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:tnt",Count:3,tag:{Tags:["stay"]}}}
summon item 1581 91 439 {Tags:["lobbyprop","itempreview","ip4"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:golden_sword",Count:1,tag:{Tags:["stay"]}}}
summon item 1583 91 439 {Tags:["lobbyprop","itempreview","ip5"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:apple",Count:1,tag:{Tags:["stay"]}}}
summon item 1585 91 439 {Tags:["lobbyprop","itempreview","ip6"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:glass",Count:1,tag:{Tags:["stay"]}}}
summon item 1587 91 439 {Tags:["lobbyprop","itempreview","ip7"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:iron_ingot",Count:1,tag:{Tags:["stay"]}}}
summon item 1589 91 439 {Tags:["lobbyprop","itempreview","ip8"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:totem_of_undying",Count:1,tag:{Tags:["stay"]}}}
summon item 1591 91 439 {Tags:["lobbyprop","itempreview","ip9"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:emerald",Count:1,tag:{Tags:["stay"]}}}
summon item 1593 91 439 {Tags:["lobbyprop","itempreview","ip10"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:gold_ingot",Count:1,tag:{Tags:["stay"]}}}

summon item 1575 91 450 {Tags:["lobbyprop","itempreview","ip11"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:ender_pearl",Count:3,tag:{Tags:["stay"]}}}
summon item 1577 91 450 {Tags:["lobbyprop","itempreview","ip12"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:elytra",Count:1,tag:{Tags:["stay"]}}}
summon item 1579 91 450 {Tags:["lobbyprop","itempreview","ip13"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:slime_block",Count:5,tag:{Tags:["stay"]}}}
summon item 1581 91 450 {Tags:["lobbyprop","itempreview","ip14"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:lingering_potion",Count:1,tag:{Tags:["stay"]}}}
summon item 1583 91 450 {Tags:["lobbyprop","itempreview","ip15"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:chicken_spawn_egg",Count:3,tag:{Tags:["stay"]}}}
summon item 1585 91 450 {Tags:["lobbyprop","itempreview","ip16"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:trapped_chest",Count:1,tag:{Tags:["stay"]}}}
summon item 1587 91 450 {Tags:["lobbyprop","itempreview","ip17"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:anvil",Count:1,tag:{Tags:["stay"]}}}
summon item 1589 91 450 {Tags:["lobbyprop","itempreview","ip18"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:enderman_spawn_egg",Count:1,tag:{Tags:["stay"]}}}
summon item 1591 91 450 {Tags:["lobbyprop","itempreview","ip19"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:squid_spawn_egg",Count:1,tag:{Tags:["stay"]}}}
summon item 1593 91 450 {Tags:["lobbyprop","itempreview","ip20"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:blaze_rod",Count:1,tag:{Tags:["stay"]}}}

#items in grocery store
summon item 1629 89.3 382 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:bread",Count:1,tag:{Tags:["stay"]}}}
summon item 1630 89.3 382 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:pumpkin_pie",Count:1,tag:{Tags:["stay"]}}}
summon item 1631 89.3 382 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:cookie",Count:3,tag:{Tags:["stay"]}}}
summon item 1632 89.3 382 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:egg",Count:3,tag:{Tags:["stay"]}}}
summon item 1633 89.3 382 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:potato",Count:1,tag:{Tags:["stay"]}}}
summon item 1634 89.3 382 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:apple",Count:1,tag:{Tags:["stay"]}}}
summon item 1635 89.3 382 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:potion",Count:1,tag:{Tags:["stay"]}}}
summon item 1636 89.3 382 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:milk_bucket",Count:1,tag:{Tags:["stay"]}}}

summon item 1629 89.3 379 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:cooked_porkchop",Count:1,tag:{Tags:["stay"]}}}
summon item 1630 89.3 379 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:cooked_beef",Count:1,tag:{Tags:["stay"]}}}
summon item 1631 89.3 379 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:cooked_chicken",Count:1,tag:{Tags:["stay"]}}}
summon item 1632 89.3 379 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:cooked_mutton",Count:1,tag:{Tags:["stay"]}}}
summon item 1633 89.3 379 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:cooked_rabbit",Count:1,tag:{Tags:["stay"]}}}
summon item 1635 89.3 379 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:cooked_cod",Count:1,tag:{Tags:["stay"]}}}
summon item 1636 89.3 379 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:cooked_salmon",Count:1,tag:{Tags:["stay"]}}}

summon item 1634 89.3 386 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:wheat_seeds",Count:1,tag:{Tags:["stay"]}}}
summon item 1634 89.3 387 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:beetroot_seeds",Count:1,tag:{Tags:["stay"]}}}
summon item 1637 89.3 386 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:melon_seeds",Count:1,tag:{Tags:["stay"]}}}
summon item 1637 89.3 387 {Tags:["lobbyprop"],PickupDelay:32767,Age:-32768,NoGravity:0,Invulnerable:1,Item:{id:"minecraft:pumpkin_seeds",Count:1,tag:{Tags:["stay"]}}}


#summon random lookin villagers to walk around
scoreboard players operation @e[name=w] rNumber = @e[limit=1,tag=random,sort=random,scores={rNumber=1..3}] rNumber
execute if entity @e[name=w,scores={rNumber=1}] run summon villager 1601 88 415 {Tags:["lobbyprop","walk"],VillagerData:{profession:mason,level:99,type:taiga},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
execute if entity @e[name=w,scores={rNumber=2}] run summon villager 1601 88 415 {Tags:["lobbyprop","walk"],VillagerData:{profession:farmer,level:99,type:desert},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}

scoreboard players operation @e[name=w] rNumber = @e[limit=1,tag=random,sort=random,scores={rNumber=1..3}] rNumber
execute if entity @e[name=w,scores={rNumber=1}] run summon villager 1601 88 398 {Tags:["lobbyprop","run"],VillagerData:{profession:cartographer,level:99,type:plains},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
execute if entity @e[name=w,scores={rNumber=2}] run summon villager 1601 88 398 {Tags:["lobbyprop","run"],VillagerData:{profession:nitwit,level:99,type:savanna},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}

scoreboard players operation @e[name=w] rNumber = @e[limit=1,tag=random,sort=random,scores={rNumber=1..3}] rNumber
execute if entity @e[name=w,scores={rNumber=1}] run summon villager 1619 88 405 {Tags:["lobbyprop","walk"],VillagerData:{profession:toolsmith,level:99,type:jungle},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
execute if entity @e[name=w,scores={rNumber=2}] run summon villager 1619 88 405 {Tags:["lobbyprop","run"],VillagerData:{profession:cleric,level:99,type:snow},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}

scoreboard players operation @e[name=w] rNumber = @e[limit=1,tag=random,sort=random,scores={rNumber=1..20}] rNumber
execute if entity @e[name=w,scores={rNumber=20}] run summon villager 1564 88 398 {Tags:["lobbyprop","walk"],VillagerData:{profession:fletcher,level:99,type:snow},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
execute if entity @e[name=w,scores={rNumber=20}] run summon villager 1566 88 398 {Tags:["lobbyprop","walk"],VillagerData:{profession:fletcher,level:99,type:snow},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
execute if entity @e[name=w,scores={rNumber=20}] run summon villager 1568 88 398 {Tags:["lobbyprop","walk"],VillagerData:{profession:fletcher,level:99,type:snow},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
execute if entity @e[name=w,scores={rNumber=20}] run summon villager 1570 88 398 {Tags:["lobbyprop","walk"],VillagerData:{profession:fletcher,level:99,type:snow},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
execute if entity @e[name=w,scores={rNumber=20}] run summon villager 1572 88 398 {Tags:["lobbyprop","walk"],VillagerData:{profession:fletcher,level:99,type:snow},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
execute if entity @e[name=w,scores={rNumber=20}] run summon villager 1574 88 398 {Tags:["lobbyprop","walk"],VillagerData:{profession:fletcher,level:99,type:snow},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}

#stationary villagers
summon villager 1628 88 385 {Tags:["lobbyprop","facesouth","lookatplayer"],VillagerData:{profession:armorer,level:99,type:savanna},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
summon villager 1630 88 383 {Tags:["lobbyprop","facewest"],VillagerData:{profession:nitwit,level:99,type:plains},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
summon villager 1633 88 389 {Tags:["lobbyprop","faceeast"],VillagerData:{profession:nitwit,level:99,type:swamp},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
summon villager 1638 88 382 {Tags:["lobbyprop","facenorth"],VillagerData:{profession:nitwit,level:99,type:savanna},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
summon villager 1626 88 378 {Tags:["lobbyprop","facesouth"],VillagerData:{profession:nitwit,level:99,type:taiga},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
summon villager 1630 88 377 {Tags:["lobbyprop","faceeast"],VillagerData:{profession:nitwit,level:99,type:desert},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}

summon villager 1626 87 434 {Tags:["lobbyprop","facenorth","lookatplayer"],VillagerData:{profession:nitwit,level:99,type:jungle},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
summon villager 1635 87.5 434 {Tags:["lobbyprop","facenorth"],VillagerData:{profession:nitwit,level:99,type:desert},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
summon villager 1633 87.5 429 {Tags:["lobbyprop","facewest"],VillagerData:{profession:nitwit,level:99,type:desert},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
summon villager 1635 87.5 425 {Tags:["lobbyprop","facesouth"],VillagerData:{profession:nitwit,level:99,type:plains},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
summon villager 1638 87.5 427 {Tags:["lobbyprop","facewest"],VillagerData:{profession:nitwit,level:99,type:snow},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}

summon villager 1576 88 430 {Tags:["lobbyprop","facewest","lookatplayer"],VillagerData:{profession:fletcher,level:99,type:snow},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}

summon villager 1569 88.25 380 {Tags:["lobbyprop","facesouth","lookatplayer"],VillagerData:{profession:cartographer,level:99,type:plains},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}
summon villager 1573 88.25 380 {Tags:["lobbyprop","facesouth","lookatplayer"],VillagerData:{profession:cartographer,level:99,type:jungle},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}

summon villager 1587 88.25 379 {Tags:["lobbyprop","facesouth","lookatplayer"],VillagerData:{profession:weaponsmith,level:99,type:plains},PersistenceRequired:1,Silent:1,NoAI:1,Invulnerable:1}

execute as @e[tag=facewest] at @s run tp @s ~ ~ ~ 90 ~
execute as @e[tag=facenorth] at @s run tp @s ~ ~ ~ 180 ~
execute as @e[tag=faceeast] at @s run tp @s ~ ~ ~ 270 ~

function sprint_racer:game_logic/0/props/spawn_preview_chest_a
function sprint_racer:game_logic/0/props/spawn_preview_chest_b