scoreboard players operation @s storedTimeMin = @e[name=w] currentTimeMin
scoreboard players operation @s storedTimeSec = @e[name=w] currentTimeSec
scoreboard players operation @s storedTimeMsec = @e[name=w] currentTimeMsec

#show all previous lap times and total time
scoreboard players set @s lapShowDelay 60

tag @s add finished
gamemode spectator @s
scoreboard players set @s lap 99
scoreboard players set @s check 0

scoreboard players set @s elytraTimer 0
scoreboard players set @s invisibility 0
scoreboard players set @s resistTime 0
scoreboard players set @s invulTime 0

#race will end 90 seconds after first finish
execute unless entity @e[name=w,scores={timeRemaining=..1800}] run scoreboard players set @e[name=w] timeRemaining 1800

tag @e[tag=latestFinish] remove latestFinish
tag @s add latestFinish
scoreboard players set @a[scores={actionbarState=..5}] actionbarState 5
scoreboard players set @a[scores={actionbarState=..5}] actionbarState2 35

execute as @a at @s run playsound minecraft:entity.firework_rocket.blast master @s ~ ~ ~ 1 1.1

#get assigned a finish position value and increment it for the next player
scoreboard players operation @s finishPos = @e[name=w,limit=1] finishPos
scoreboard players add @e[name=w] finishPos 1

#get assigned a "addPoints" value
#players get a minimum of 1 point for finishing
scoreboard players set @s addPoints 0
scoreboard players operation @s addPoints = @e[name=w,limit=1] addPoints
scoreboard players set @s[scores={addPoints=..0}] addPoints 1
scoreboard players remove @e[name=w] addPoints 1

#bonuses are awarded for 1st and 2nd
scoreboard players add @s[scores={finishPos=1}] addPoints 2
scoreboard players add @s[scores={finishPos=2}] addPoints 1

function sprint_racer_language:gameplay/race_finish_text
function sprint_racer_language:gameplay/race_finish_text_spectator/_index
team join playerFinished @s
scoreboard players set @s subtitleDelay 60