#enderman thief
tag @e[tag=endieMoved] remove endieMoved
execute if entity @e[scores={enderman=..999}] run function sprint_racer:items/item_tick/enderman_thief
execute if entity @e[scores={enderSteal=..999}] run function sprint_racer:items/item_tick/enderman_stealing

#players holding an item tagged with "stronk" are allowed to attack other players
effect clear @a[tag=playing,nbt={SelectedItem:{tag:{Tags:["stronk"]}}}] weakness

#certain item drops deploy on contact with the ground
scoreboard players add @e[type=item,nbt={Item:{tag:{Tags:["groundDeploy"]}}}] age 1
execute as @e[type=item,scores={age=1},nbt={Item:{tag:{Tags:["groundDeploy"]}}}] at @s run scoreboard players operation @s playerID = @e[limit=1,sort=nearest,tag=playing,gamemode=!spectator] playerID
execute as @e[type=item,nbt={OnGround:1b,Item:{tag:{Tags:["groundDeploy"]}}}] at @s run function sprint_racer:items/item_tick/deploy_on_ground/_index

#area effect cloud
execute as @e[type=area_effect_cloud,tag=!nasty,nbt={Potion:"minecraft:poison"}] at @s run function sprint_racer:items/item_tick/poison_cloud
execute as @e[type=area_effect_cloud,tag=!bignasty,nbt={Potion:"minecraft:strong_poison"}] at @s run function sprint_racer:items/item_tick/poison_cloud_big

#resistance given by resistance nodes override other stuff
scoreboard players remove @e[scores={nResist=1..}] nResist 1

#eat golden apple
execute if entity @e[scores={eatGoldApple=..999}] run function sprint_racer:items/item_tick/golden_apple

#invisibility
execute if entity @e[scores={invisibility=1..}] run function sprint_racer:items/item_tick/invisibility

#resistance
execute if entity @e[scores={resistTime=1..}] run function sprint_racer:items/item_tick/resistance

#invincibility
execute if entity @e[scores={invulTime=1..}] run function sprint_racer:items/item_tick/invincibility

#pickup timer
execute as @e[scores={itemCooldown=1..}] run function sprint_racer:items/item_tick/pickup_timer

#lightning storm
execute as @e[name=w,scores={storm=..9999}] run function sprint_racer:items/item_tick/lightning_storm

#anvil
execute if entity @e[scores={anvil=..999}] run function sprint_racer:items/item_tick/anvil_player
execute as @e[tag=anvil] at @s run function sprint_racer:items/item_tick/anvil_entity

#totem of undying
execute as @a[scores={useTotem=..999}] at @s run function sprint_racer:items/item_tick/totem_used

#throw ender pearl
execute as @a[scores={usePearl=..999}] at @s run function sprint_racer:items/item_tick/pearl_used
execute as @e[type=ender_pearl] at @s run particle minecraft:enchanted_hit ~ ~ ~ .0 0 0 0 1 force

#warp
#execute as @e[scores={useEye=..999}] at @s run kill @e[type=eye_of_ender]
execute as @e[scores={useEye=..999}] at @s run function sprint_racer:items/item_tick/elite/warp/_index


bossbar set minecraft:control_openwings players @a[nbt={FallFlying:0b,OnGround:0b},scores={elytraTimer=50..}]

#elytra (note: this only applies to human players, AI elytra stuff is handled elsewhere)
execute as @a[nbt={Inventory:[{Slot:102b,id:"minecraft:elytra",Count:1b,tag:{Tags:["item"]}}]}] at @s run function sprint_racer:items/item_tick/elytra_found
execute as @a[scores={elytraTimer=1..}] at @s run function sprint_racer:items/item_tick/elytra

#IMPORTANT!!!
#handle right-clicks for using some items
execute as @a[scores={inputCooldown=..0,carrotInput=..999},nbt={SelectedItem:{tag:{Tags:["item"]}}}] at @s run function sprint_racer:items/item_tick/normal_or_elite

#chicken mine
execute if entity @e[tag=chickenmine] run function sprint_racer:items/item_tick/chicken_mine
execute if entity @e[tag=cminezombie] run function sprint_racer:items/item_tick/chicken_mine_zombie

#generic explosion
execute if entity @e[tag=explosion] run function sprint_racer:items/item_tick/explosion

#tnt
execute if entity @e[type=tnt] run function sprint_racer:items/item_tick/tnt

#CUT, this was jank and I found a better way to make TNT work
#return to adventure mode if the player was briefly sent to creative
#gamemode adventure @a[tag=returnAdv2]
#effect clear @a[tag=returnAdv2,scores={nResist=..0}] resistance
#tag @a[tag=returnAdv2] remove returnAdv2
#tag @a[tag=returnAdv] add returnAdv2
#tag @a[tag=returnAdv] remove returnAdv

#projectile safety cooldown
scoreboard players remove @e[scores={projectileSafe=1..}] projectileSafe 1
scoreboard players remove @e[scores={lightningSafe=1..}] lightningSafe 1


#slime and magma traps
execute if entity @e[tag=slimetrap] run function sprint_racer:items/item_tick/slime_trap
execute if entity @e[tag=magmatrap] run function sprint_racer:items/item_tick/magma_trap

#poison clouds give zombies regeneration which is essentially their poison
execute if entity @e[tag=ai] as @e[tag=trap,tag=nasty] at @s run function sprint_racer:items/item_tick/poison_cloud_ai
execute if entity @e[tag=ai] as @e[tag=trap,tag=bignasty] at @s run function sprint_racer:items/item_tick/poison_cloud_ai_big

#generic "electrocution" effect
execute if entity @e[scores={electrocute=..999}] run function sprint_racer:items/item_tick/electrocute

#generic "burn" effect
execute if entity @e[scores={burn=..999}] run function sprint_racer:items/item_tick/burn

#visual "blindness" effect
execute as @e[scores={blindtime=1..}] at @s run function sprint_racer:items/item_tick/blindness_visual

#some projectiles...
execute if entity @e[type=snowball,tag=!mHitbox] run function sprint_racer:items/item_tick/snowball
execute if entity @e[tag=missile] run function sprint_racer:items/item_tick/missile

#repeat stuff if in half tick mode
execute if entity @e[name=w,tag=halftick] run function sprint_racer:items/item_tick/_main_echo